CON

'standard pin definitions
#0, NOT_USED
KEYBOARD1                                                                       'Primary keyboard
MOUSE1                                                                          'Primary mouse
TV_DAC1                                                                         'Primary TV
VGA1                                                                            'Primary VGA
AUDIO1,AUDIO2                                                                   'Primary/Secondary Audio
FSRW1_DO,FSRW1_CLK,FSRW1_DI,FSRW1_CS                                            'Primary SD media connections
DS1302_INCLK,DS1302_INIO,DS1302_CS                                              'DS1302 clock
DEBUG_TX,DEBUG_RX                                                               'serial debug serial port
GPS_TX,GPS_RX                                                                   'serial gps serial port
CMUCAM_TX,CMUCAM_RX                                                             'cmucam serial port
XBEE_TX,XBEE_RX                                                                 'XBBE serial port
HYDRANET_TX,HYDRANET_RX                                                         'HYDRA Net
IRDETECT,IREMIT                                                                 'IR Emit/detect
PING_DATA                                                                       'Ping Sensor
JOY_CLK,JOY_SHLDN,JOY_DATAOUT0,JOY_DATAOUT1                                     'Nes controller configuration
PG_RXPIN,PG_TXPIN                                                               'PropGFX Lite configuration
DEBUG_LED1,DEBUG_LED2,DEBUG_LED3                                                'some leds for debugging
ENC1_SCK,ENC1_SI,ENC1_SO,ENC1_INT                                               'ENC28J60 Ethernet
HM55BEna,HM55BClk,HM55BDI,HM55BDO                                               'HM55B compass
I2C_SCL1, I2C_SDA1                                                              'primary I2C
I2C_SCL2, I2C_SDA2                                                              'secondary I2C
SERVO1, SERVO2, SERVO3,SERVO4                                                   'servos
SERVO5, SERVO6, SERVO7,SERVO8                                                   'servos
SERVO9, SERVO10, SERVO11,SERVO12                                                'servos
SERVO13, SERVO14, SERVO15,SERVO16                                               'servos
HB25_1,HB25_2,HB25_3,HB25_4                                                     'motor controllers
QE_1,QE_2,QE_3,QE_4                                                             'Quad encoder
QE_5,QE_6,QE_7,QE_8                                                             'Quad encoder
QE_9,QE_10,QE_11,QE_12                                                          'Quad encoder
QE_13,QE_14,QE_15,QE_16                                                         'Quad encoder
VEXDEMUX                                                                        'VEX RC receiver

'Magic number - change if you change the structure of the table
MAGICNUMBER      = $AAAAAAAA
'4 - magic no, 4 - clkfreq, 1 clkreg, 7 pins, 1 ntsc/pin
STANDARDADDRESS = $8000-4-4-1-7-1                                               'top of 32k eeprom
'offsets into table
MAGIC_OFFSET      = 0
CLKFREQ_OFFSET    = 4
CLKMODE_OFFSET    = 8
KEYBOARD_OFFSET   = 9
TV_DAC_OFFSET     = 10
VGA_OFFSET        = 11
FSRW1_DO_OFFSET   = 12
FSRW1_CLK_OFFSET  = 13
FSRW1_DI_OFFSET   = 14
FSRW1_CS_OFFSET   = 15
NTSC_PAL_OFFSET   = 16                                          

'NTSC/PAL values
NTSC             = 0
PAL              = 1

VAR
  LONG PINS
  
PUB Init(addr) | i
  PINS := addr
  if LONG[STANDARDADDRESS] == MAGICNUMBER                                       'see if we find a config table at ram location
    clkset(BYTE[STANDARDADDRESS+CLKMODE_OFFSET], LONG[STANDARDADDRESS+CLKFREQ_OFFSET])
    if (i := BYTE[STANDARDADDRESS+KEYBOARD_OFFSET]) <> -1                       'keyboard configured by OS?
      if CheckSpecial(i)
        word[PINS][i] := KEYBOARD1
    if (i := BYTE[STANDARDADDRESS+TV_DAC_OFFSET]) <> -1                         'TV configured by OS?
      if CheckSpecial(i)
        word[PINS][i] := TV_DAC1
    if (i := BYTE[STANDARDADDRESS+VGA_OFFSET]) <> -1                            'VGA configured by OS?
      if CheckSpecial(i)
        word[PINS][i] := VGA1
    if (i := BYTE[STANDARDADDRESS+FSRW1_DO_OFFSET]) <> -1                       'SD configured by OS?
      if CheckSpecial(i)
        word[PINS][i] := FSRW1_DO
    if (i := BYTE[STANDARDADDRESS+FSRW1_CLK_OFFSET]) <> -1
      if CheckSpecial(i)
        word[PINS][i] := FSRW1_CLK
    if (i := BYTE[STANDARDADDRESS+FSRW1_DI_OFFSET]) <> -1
      if CheckSpecial(i)
        word[PINS][i] := FSRW1_DI
    if (i := BYTE[STANDARDADDRESS+FSRW1_CS_OFFSET]) <> -1
      if CheckSpecial(i)
        word[PINS][i] := FSRW1_CS
    byte[PINS][64] := BYTE[STANDARDADDRESS+NTSC_PAL_OFFSET]
  elseif CheckSpecial(12) AND CheckSpecial(13)                                  'no table try hardware detect if pins 12 and 13 are used by standard devices
     HWDetect
    
PRI CheckSpecial(i) | ok, check
  ok := false
  repeat check from 0 to 7
    if SPECIAL[check] == word[PINS][i]
      ok := true
      quit
  return ok

' This routine is a modifed version of
' //////////////////////////////////////////////////////
' AUTHOR: Coley
' LAST MODIFIED: 23.06.08
' VERSION 1
' COMMENTS: Routine for checking Hardware configurations
'           of various Propeller based boards.             
' //////////////////////////////////////////////////////
'
'  Power on harware configurations for target boards
'
'                      Pin Number
'
'            00000000001111111111222222222233
'            01234567890123456789012345678901
'
'                                    vdac
' Hybrid     000000001111111100000000OOOO1111
'
'                        vdac
' Demoboard  000000000000OOOO0000000011110111
'
'                                    vdac
' Hydra      010001000101010111110000OOOO??11 
'
' For this application we will check the status
' of P12..P13
'
' %00 - Demo/Protoboard
' %01 - Hydra
' %11 - Hybrid
'
' //////////////////////////////////////////////////////
PRI  HWDetect | HWPins
  clkset(%01101000,  12_000_000)                        ' Set internal oscillator to RCFast and set PLL to start
  waitcnt(cnt+120_000)                                  ' wait approx 10ms at 12mhz for PLL to 'warm up'
  
  HWPins := INA[12..13]                                 ' Check state of Pins 12-13

  CASE HWPins
    %00 : clkset( %01101111, 80_000_000 )               ' Demo Board   80MHz (5MHz PLLx16)
          word[PINS][12] := TV_DAC1
          word[PINS][13] := TV_DAC1
          word[PINS][14] := TV_DAC1
          word[PINS][15] := TV_DAC1
          word[PINS][16] := VGA1
          word[PINS][17] := VGA1
          word[PINS][18] := VGA1
          word[PINS][19] := VGA1
          word[PINS][20] := VGA1
          word[PINS][21] := VGA1
          word[PINS][22] := VGA1
          word[PINS][23] := VGA1
          word[PINS][26] := KEYBOARD1
          word[PINS][27] := KEYBOARD1
    %01 : clkset( %01110110, 80_000_000 )               ' Hydra        80MHz (10MHz PLLx8)
          word[PINS][12] := KEYBOARD1
          word[PINS][13] := KEYBOARD1
          word[PINS][24] := TV_DAC1
          word[PINS][25] := TV_DAC1
          word[PINS][26] := TV_DAC1
          word[PINS][27] := TV_DAC1
    %11 : clkset( %01101111, 96_000_000 )               ' Hybrid       96MHz (6MHz PLLx16)
          word[PINS][12] := KEYBOARD1
          word[PINS][13] := KEYBOARD1
          word[PINS][24] := TV_DAC1
          word[PINS][25] := TV_DAC1
          word[PINS][26] := TV_DAC1
          word[PINS][27] := TV_DAC1
          word[PINS][8]  := FSRW1_DO
          word[PINS][9]  := FSRW1_CLK
          word[PINS][10] := FSRW1_DI
          word[PINS][11] := FSRW1_CS
   
PUB GetPin(Type) | index, addr
  repeat index from 0 to 31
    if word[PINS][index] == Type
      return index
  return -1

PUB GetType(Pin)
'return whats on a pin
  return word[PINS][Pin]
  
PUB GetNTSCPAL
  return byte[PINS][64]
  
DAT
SPECIAL       word NOT_USED,KEYBOARD1,TV_DAC1,VGA1,FSRW1_DO,FSRW1_CLK,FSRW1_DI,FSRW1_CS  'pins that are ok to overwrite
                                                                                            